import javax.xml.parsers.DocumentBuilder; 
import javax.xml.parsers.DocumentBuilderFactory;  
import javax.xml.parsers.FactoryConfigurationError;  
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;  
import org.xml.sax.SAXParseException;
import java.io.File;
import java.io.IOException;
import org.w3c.dom.Document;
import org.w3c.dom.DOMException;

import java.util.*;
 




    public class AdapterNode 
    { 
      org.w3c.dom.Node domNode;

      // Construct an Adapter node from a DOM node
      public AdapterNode(org.w3c.dom.Node node) {
        domNode = node;
      }

	// return the unique String value of the uniquely identified child node
	public String getChildValue( String elemtag ) {

	    AdapterNode wrkNode;
	    String rtnStr = new String("***Error***");
	    boolean bFnd = false;

	    System.out.println( "getChildValue: " + elemtag );

	    if ( domNode.hasChildNodes() ) {
		for ( int j = 0; j < domNode.getChildNodes().getLength() && !bFnd; j++ ) {
		    if ( domNode.getChildNodes().item(j).getNodeType() == ELEMENT_TYPE ) {
			if ( domNode.getChildNodes().item(j).getNodeName().equals( elemtag ) ) {
			    wrkNode = new AdapterNode(domNode.getChildNodes().item(j));
			    rtnStr = new String( domNode.getChildNodes().item(j).getChildNodes().item(0).getNodeValue() );
			    bFnd = true;
			}
		    }
		}
	    }

	    return(rtnStr);

	} // end getChildValue

	// return the unique String value of the uniquely identified MBean.ServerName.metric
	public String getObsValue( String mbeanStr, String nameStr, String metricStr ) {

	    AdapterNode wrkNode;
	    AdapterNode wrk2Node;
	    String rtnStr = new String("***Error***");
	    boolean bFnd = false;

	    System.out.println( "getObsValue: " + mbeanStr + " " + nameStr + " " + metricStr );

	    if ( domNode.hasChildNodes() ) {
		for ( int j = 0; j < domNode.getChildNodes().getLength() && !bFnd; j++ ) {
		    if ( domNode.getChildNodes().item(j).getNodeType() == ELEMENT_TYPE ) {
			if ( domNode.getChildNodes().item(j).getNodeName().equals( mbeanStr ) ) {
			    wrkNode = new AdapterNode( domNode.getChildNodes().item(j) );
			    for ( int k = 0; k < wrkNode.domNode.getChildNodes().getLength() && !bFnd; k++ ) {
				if ( wrkNode.domNode.getChildNodes().item(k).getNodeType() == ELEMENT_TYPE ) {
				    wrk2Node = new AdapterNode( wrkNode.domNode.getChildNodes().item(k) );
				    if ( wrk2Node.domNode.getNodeName().equals( "Name" ) ) {
					System.out.println( "---" + wrk2Node.domNode.getNodeName() );
					System.out.println( "   " + wrk2Node.domNode.getChildNodes().item(0).getNodeValue() );
					if ( wrk2Node.domNode.getChildNodes().item(0).getNodeValue().trim().equals( nameStr ) ) {
					    bFnd = true;
					    rtnStr = new String( wrkNode.getChildValue( metricStr ) );
					}
				    }
				}
			    }
			}
		    }
		}
	    }
			  
			    			    
	    return(rtnStr);

	} // end getObsValue

	// return the unique String value of the uniquely identified MBean.metric
	public String getObsValue( String mbeanStr, String metricStr ) {

	    AdapterNode wrkNode;
	    AdapterNode wrk2Node;
	    String rtnStr = new String("***Error***");
	    boolean bFnd = false;

	    System.out.println( "getObsValue: " + mbeanStr + " " + metricStr );

	    if ( domNode.hasChildNodes() ) {
		for ( int j = 0; j < domNode.getChildNodes().getLength() && !bFnd; j++ ) {
		    if ( domNode.getChildNodes().item(j).getNodeType() == ELEMENT_TYPE ) {
			if ( domNode.getChildNodes().item(j).getNodeName().equals( mbeanStr ) ) {
			    wrkNode = new AdapterNode( domNode.getChildNodes().item(j) );
			    for ( int k = 0; k < wrkNode.domNode.getChildNodes().getLength() && !bFnd; k++ ) {
				if ( wrkNode.domNode.getChildNodes().item(k).getNodeType() == ELEMENT_TYPE ) {
				    wrk2Node = new AdapterNode( wrkNode.domNode.getChildNodes().item(k) );
				    if ( wrk2Node.domNode.getNodeName().equals( metricStr ) ) {
					System.out.println( "---" + wrk2Node.domNode.getNodeName() );
					System.out.println( "   " + wrk2Node.domNode.getChildNodes().item(0).getNodeValue() );
					
					    bFnd = true;
					    rtnStr = new String(wrk2Node.domNode.getChildNodes().item(0).getNodeValue());
					
				    }
				}
			    }
			}
		    }
		}
	    }
			  
			    			    
	    return(rtnStr);

	} // end getObsValue

    static final int ELEMENT_TYPE =   1;
    static final int ATTR_TYPE =      2;
    static final int TEXT_TYPE =      3;
    static final int CDATA_TYPE =     4;
    static final int ENTITYREF_TYPE = 5;
    static final int ENTITY_TYPE =    6;
    static final int PROCINSTR_TYPE = 7;
    static final int COMMENT_TYPE =   8;
    static final int DOCUMENT_TYPE =  9;
    static final int DOCTYPE_TYPE =  10;
    static final int DOCFRAG_TYPE =  11;
    static final int NOTATION_TYPE = 12; 

    
} // AdapterNode





